import { Tree } from "tree-sitter";
import { Exposing } from "./util/treeUtils";
export interface ITreeContainer {
    uri: string;
    writable: boolean;
    referenced: boolean;
    moduleName: string;
    exposing: Exposing;
    tree: Tree;
}
export interface IForest {
    treeIndex: ITreeContainer[];
    getTree(uri: string): Tree | undefined;
    getExposingByModuleName(moduleName: string): Exposing | undefined;
    getTreeByModuleName(moduleName: string): Tree | undefined;
    getByModuleName(moduleName: string): ITreeContainer | undefined;
    getByUri(uri: string): ITreeContainer | undefined;
    setTree(uri: string, writable: boolean, referenced: boolean, tree: Tree): void;
    removeTree(uri: string): void;
}
export declare class Forest implements IForest {
    treeIndex: ITreeContainer[];
    constructor();
    getTree(uri: string): Tree | undefined;
    getExposingByModuleName(moduleName: string): Exposing | undefined;
    getTreeByModuleName(moduleName: string): Tree | undefined;
    getByModuleName(moduleName: string): ITreeContainer | undefined;
    getByUri(uri: string): ITreeContainer | undefined;
    setTree(uri: string, writable: boolean, referenced: boolean, tree: Tree): void;
    removeTree(uri: string): void;
}
