"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
class CodeActionProvider {
    constructor(connection, elmAnalyse) {
        this.connection = connection;
        this.elmAnalyse = elmAnalyse;
        this.onCodeAction = this.onCodeAction.bind(this);
        this.onExecuteCommand = this.onExecuteCommand.bind(this);
        this.connection.onCodeAction(this.onCodeAction);
        this.connection.onExecuteCommand(this.onExecuteCommand);
    }
    onCodeAction(params) {
        return this.elmAnalyse.onCodeAction(params);
    }
    onExecuteCommand(params) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.elmAnalyse.onExecuteCommand(params);
        });
    }
}
exports.CodeActionProvider = CodeActionProvider;
//# sourceMappingURL=codeActionProvider.js.map