/// <reference types="node" />
import { EventEmitter } from "events";
import { Connection, DidChangeTextDocumentParams, DidCloseTextDocumentParams, DidOpenTextDocumentParams, DidSaveTextDocumentParams } from "vscode-languageserver";
declare type DidChangeCallback = (params: DidChangeTextDocumentParams) => void;
declare type DidCloseCallback = (params: DidCloseTextDocumentParams) => void;
declare type DidOpenCallback = (params: DidOpenTextDocumentParams) => void;
declare type DidSaveCallback = (params: DidSaveTextDocumentParams) => void;
export interface IDocumentEvents {
    on(event: "change", listener: DidChangeCallback): this;
    on(event: "close", listener: DidCloseCallback): this;
    on(event: "open", listener: DidOpenCallback): this;
    on(event: "save", listener: DidSaveCallback): this;
}
export declare class DocumentEvents extends EventEmitter implements IDocumentEvents {
    constructor(connection: Connection);
}
export {};
